searchNodes=[{"doc":"General functions to work with JOSE","ref":"JOSEUtils.html","title":"JOSEUtils","type":"module"},{"doc":"Returns true if the string is an encrypted JWT, false otherwise Example iex&gt; jwe_token = &quot;eyJhbGciOiJBMTI4R0NNS1ciLCJlbmMiOiJBMTI4R0NNIiwiaXYiOiJzODNFNjhPNjhsWlM5ZVprIiwidGFnIjoieF9Ea2M5dm1LMk5RQV8tU2hvTkFRdyJ9.8B2qX8fVEa-s61RsZXqkCg.J7yJ8sKLbUlzyor6.FRs.BhBwImTv9B14NwVuxmfU6A&quot; &quot;eyJhbGciOiJBMTI4R0NNS1ciLCJlbmMiOiJBMTI4R0NNIiwiaXYiOiJzODNFNjhPNjhsWlM5ZVprIiwidGFnIjoieF9Ea2M5dm1LMk5RQV8tU2hvTkFRdyJ9.8B2qX8fVEa-s61RsZXqkCg.J7yJ8sKLbUlzyor6.FRs.BhBwImTv9B14NwVuxmfU6A&quot; iex&gt; JOSEUtils.is_jwe?(jwe_token) true iex&gt; jws_token = &quot;eyJhbGciOiJFZDI1NTE5In0.e30.xyg2LTblm75KbLFJtROZRhEgAFJdlqH9bhx8a9LO1yvLxNLhO9fLqnFuU3ojOdbObr8bsubPkPqUfZlPkGHXCQ&quot; &quot;eyJhbGciOiJFZDI1NTE5In0.e30.xyg2LTblm75KbLFJtROZRhEgAFJdlqH9bhx8a9LO1yvLxNLhO9fLqnFuU3ojOdbObr8bsubPkPqUfZlPkGHXCQ&quot; iex&gt; JOSEUtils.is_jwe?(jws_token) false","ref":"JOSEUtils.html#is_jwe?/1","title":"JOSEUtils.is_jwe?/1","type":"function"},{"doc":"Returns true if the string is an signed JWT, false otherwise iex(2)&gt; JOSEUtils.is_jws?(&quot;eyJhbGciOiJIUzI1NiJ9.e30.5paAJxaOXSqRUIXrP_vJXUZu2SCBH-ojgP4D6Xr6GPU&quot;) true iex(3)&gt; JOSEUtils.is_jws?(&quot;Some.string&quot;) false","ref":"JOSEUtils.html#is_jws?/1","title":"JOSEUtils.is_jws?/1","type":"function"},{"doc":"Helper functions to work with JOSE algorithms","ref":"JOSEUtils.JWA.html","title":"JOSEUtils.JWA","type":"module"},{"doc":"Returns the JOSE algorithm from aan X509 signature algorithm, or nil if it has no JOSE equivalent","ref":"JOSEUtils.JWA.html#x509_to_jose_sig_alg/1","title":"JOSEUtils.JWA.x509_to_jose_sig_alg/1","type":"function"},{"doc":"Algorithm (&quot;alg&quot;) used for encryption One of: &quot;A128GCMKW&quot; &quot;A128KW&quot; &quot;A192GCMKW&quot; &quot;A192KW&quot; &quot;A256GCMKW&quot; &quot;A256KW&quot; &quot;C20PKW&quot; &quot;ECDH-1PU&quot; &quot;ECDH-1PU+A128GCMKW&quot; &quot;ECDH-1PU+A128KW&quot; &quot;ECDH-1PU+A192GCMKW&quot; &quot;ECDH-1PU+A192KW&quot; &quot;ECDH-1PU+A256GCMKW&quot; &quot;ECDH-1PU+A256KW&quot; &quot;ECDH-1PU+C20PKW&quot; &quot;ECDH-ES&quot; &quot;ECDH-ES+A128GCMKW&quot; &quot;ECDH-ES+A128KW&quot; &quot;ECDH-ES+A192GCMKW&quot; &quot;ECDH-ES+A192KW&quot; &quot;ECDH-ES+A256GCMKW&quot; &quot;ECDH-ES+A256KW&quot; &quot;ECDH-ES+C20PKW&quot; &quot;PBES2-HS256+A128GCMKW&quot; &quot;PBES2-HS256+A128KW&quot; &quot;PBES2-HS384+A192GCMKW&quot; &quot;PBES2-HS384+A192KW&quot; &quot;PBES2-HS512+A256GCMKW&quot; &quot;PBES2-HS512+A256KW&quot; &quot;PBES2-HS512+C20PKW&quot; &quot;RSA-OAEP&quot; &quot;RSA-OAEP-256&quot; &quot;RSA1_5&quot; &quot;dir&quot;","ref":"JOSEUtils.JWA.html#t:enc_alg/0","title":"JOSEUtils.JWA.enc_alg/0","type":"type"},{"doc":"Encryption (&quot;enc&quot;) algorithm used for encryption One of: &quot;A128CBC-HS256&quot; &quot;A128GCM&quot; &quot;A192CBC-HS384&quot; &quot;A192GCM&quot; &quot;A256CBC-HS512&quot;, &quot;A256GCM&quot; &quot;C20P&quot; &quot;XC20P&quot;","ref":"JOSEUtils.JWA.html#t:enc_enc/0","title":"JOSEUtils.JWA.enc_enc/0","type":"type"},{"doc":"Signature algorithm One of: &quot;Ed25519&quot; &quot;Ed448&quot; &quot;EdDSA&quot; &quot;ES256&quot; &quot;ES384&quot; &quot;ES512&quot; &quot;HS256&quot; &quot;HS384&quot; &quot;HS512&quot; &quot;Poly1305&quot; &quot;PS256&quot; &quot;PS384&quot; &quot;PS512&quot; &quot;RS256&quot; &quot;RS384&quot; &quot;RS512&quot; &quot;none&quot;","ref":"JOSEUtils.JWA.html#t:sig_alg/0","title":"JOSEUtils.JWA.sig_alg/0","type":"type"},{"doc":"Convenience function to work with encrypted JWTs","ref":"JOSEUtils.JWE.html","title":"JOSEUtils.JWE","type":"module"},{"doc":"Decrypts a JWE encrypted token and returns the decryption key It filters the keys to select only those suitable for decryption, using JOSEUtils.JWKS.decryption_keys/3. If the JWE has an identifier (&quot;kid&quot;), it only uses that specific key. Example iex&gt; jwk_oct256 = JOSE.JWK.from_oct(&lt;&lt;0::256&gt;&gt;) iex&gt; jwk_oct256_map = JOSE.JWK.from_oct(&lt;&lt;0::256&gt;&gt;) |&gt; JOSE.JWK.to_map() |&gt; elem(1) iex&gt; encrypted_a256gcmkw = JOSE.JWE.block_encrypt(jwk_oct256, &quot;{}&quot;, %{ &quot;alg&quot; =&gt; &quot;A256GCMKW&quot;, &quot;enc&quot; =&gt; &quot;A256GCM&quot; }) |&gt; JOSE.JWE.compact |&gt; elem(1) iex&gt; JOSEUtils.JWE.decrypt(encrypted_a256gcmkw, jwk_oct256_map, [&quot;A256KW&quot;], [&quot;A256GCM&quot;]) :error iex&gt; JOSEUtils.JWE.decrypt(encrypted_a256gcmkw, jwk_oct256_map, [&quot;A256KW&quot;, &quot;A256GCMKW&quot;], [&quot;A256GCM&quot;]) {:ok, {&quot;{}&quot;, %{&quot;k&quot; =&gt; &quot;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA&quot;, &quot;kty&quot; =&gt; &quot;oct&quot;}}}","ref":"JOSEUtils.JWE.html#decrypt/4","title":"JOSEUtils.JWE.decrypt/4","type":"function"},{"doc":"Returns the JOSE algorithm name from a %JOSE.JWE{} structure iex&gt; jwk_oct128 = JOSE.JWK.from_oct(&lt;&lt;0::128&gt;&gt;) iex&gt; encrypted_a128gcmkw = JOSE.JWE.block_encrypt(jwk_oct128, &quot;{}&quot;, %{ &quot;alg&quot; =&gt; &quot;A128GCMKW&quot;, &quot;enc&quot; =&gt; &quot;A128GCM&quot; }) |&gt; JOSE.JWE.compact |&gt; elem(1) iex&gt; JOSE.JWE.block_decrypt(jwk_oct128, encrypted_a128gcmkw) |&gt; elem(1) |&gt; JOSEUtils.JWE.jose_alg() &quot;A128GCMKW&quot;","ref":"JOSEUtils.JWE.html#jose_alg/1","title":"JOSEUtils.JWE.jose_alg/1","type":"function"},{"doc":"Returns the JOSE encryption algorithm name from a %JOSE.JWE{} structure","ref":"JOSEUtils.JWE.html#jose_enc/1","title":"JOSEUtils.JWE.jose_enc/1","type":"function"},{"doc":"Serialized JWE encrypted token For instance: &quot;eyJhbGciOiJBMTI4R0NNS1ciLCJlbmMiOiJBMTI4R0NNIiwiaXYiOiJzODNFNjhPNjhsWlM5ZVprIiwidGFnIjoieF9Ea2M5dm1LMk5RQV8tU2hvTkFRdyJ9.8B2qX8fVEa-s61RsZXqkCg.J7yJ8sKLbUlzyor6.FRs.BhBwImTv9B14NwVuxmfU6A&quot;","ref":"JOSEUtils.JWE.html#t:serialized/0","title":"JOSEUtils.JWE.serialized/0","type":"type"},{"doc":"Convenience functions to work with JWKs","ref":"JOSEUtils.JWK.html","title":"JOSEUtils.JWK","type":"module"},{"doc":"Returns the digest used by a signature algorithm of the key","ref":"JOSEUtils.JWK.html#sig_alg_digest/1","title":"JOSEUtils.JWK.sig_alg_digest/1","type":"function"},{"doc":"Verifies a JWK It performs the following checks: verifies that the &quot;x5c&quot; member (if present) against: the JWK key the &quot;alg&quot; member the &quot;use&quot; member the &quot;key_ops&quot; member the &quot;x5t&quot; member, if present the &quot;x5t#S256&quot; member, if present validates the certificate chain verifies that the &quot;use&quot; and &quot;key_ops&quot; members are consistent verifies that the &quot;key_ops&quot; operations are related to each other","ref":"JOSEUtils.JWK.html#verify/1","title":"JOSEUtils.JWK.verify/1","type":"function"},{"doc":"","ref":"JOSEUtils.JWK.html#t:alg/0","title":"JOSEUtils.JWK.alg/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWK.html#t:certificate/0","title":"JOSEUtils.JWK.certificate/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWK.html#t:result/0","title":"JOSEUtils.JWK.result/0","type":"type"},{"doc":"A JSON Web Key in its map form For instance: %{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;x&quot; =&gt; &quot;6pwDpICQ8JBWdvuLuXeWILAxSEUNB_BBAswikgYKKmY&quot;, &quot;y&quot; =&gt; &quot;fEHj1ehsIJ7PP-qon-oONl_J2yZLWpUncNRedZT7xqs&quot; }","ref":"JOSEUtils.JWK.html#t:t/0","title":"JOSEUtils.JWK.t/0","type":"type"},{"doc":"Convenience function to work with JWK sets","ref":"JOSEUtils.JWKS.html","title":"JOSEUtils.JWKS","type":"module"},{"doc":"Returns the keys suitable for decryption from a JWK set","ref":"JOSEUtils.JWKS.html#decryption_keys/3","title":"JOSEUtils.JWKS.decryption_keys/3","type":"function"},{"doc":"Returns the keys suitable for encryption from a JWK set","ref":"JOSEUtils.JWKS.html#encryption_keys/3","title":"JOSEUtils.JWKS.encryption_keys/3","type":"function"},{"doc":"Returns the keys suitable for signature from a JWK set Note that it does not return the keys suitable only for signature verification. MAC keys are considered signature keys, and are returned as well.","ref":"JOSEUtils.JWKS.html#signature_keys/2","title":"JOSEUtils.JWKS.signature_keys/2","type":"function"},{"doc":"Returns the keys suitable for signature verification from a JWK set MAC keys are considered verification keys, and are returned as well.","ref":"JOSEUtils.JWKS.html#verification_keys/2","title":"JOSEUtils.JWKS.verification_keys/2","type":"function"},{"doc":"","ref":"JOSEUtils.JWKS.html#t:t/0","title":"JOSEUtils.JWKS.t/0","type":"type"},{"doc":"Convenience functions to work with signed JWTs","ref":"JOSEUtils.JWS.html","title":"JOSEUtils.JWS","type":"module"},{"doc":"Verifies the signature of a JWS, and returns its content and the signature key The function also filters the key using JOSEUtils.JWKS.verification_keys/2 with the whitelisted signature algorithms. If the JWS has an identifier (&quot;kid&quot;), it only uses that specific key. Example iex&gt; JOSE.crypto_fallback(true) iex&gt; jwk_ed25519 = JOSE.JWK.generate_key({:okp, :Ed25519}) iex&gt; jwk_ed25519_map = jwk_ed25519 |&gt; JOSE.JWK.to_map() |&gt; elem(1) iex&gt; signed_ed25519 = JOSE.JWS.sign(jwk_ed25519, &quot;{}&quot;, %{ &quot;alg&quot; =&gt; &quot;Ed25519&quot; }) |&gt; JOSE.JWS.compact |&gt; elem(1) iex&gt; JOSEUtils.JWS.verify(signed_ed25519, jwk_ed25519_map, [&quot;RS256&quot;]) :error iex&gt; JOSEUtils.JWS.verify(signed_ed25519, jwk_ed25519_map, [&quot;Ed25519&quot;]) |&gt; elem(0) :ok","ref":"JOSEUtils.JWS.html#verify/3","title":"JOSEUtils.JWS.verify/3","type":"function"},{"doc":"Serialized JWS signed token For instance: &quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwibmFtZSI6IkpvaG4gRG9lIiwiaWF0IjoxNTE2MjM5MDIyfQ.SflKxwRJSMeKKF2QT4fwpMeJf36POk6yJV_adQssw5c&quot;","ref":"JOSEUtils.JWS.html#t:serialized/0","title":"JOSEUtils.JWS.serialized/0","type":"type"},{"doc":"JOSEUtils Convenience functions to work with JOSE (JSON Object Signing and Encryption)","ref":"readme.html","title":"JOSEUtils","type":"extras"},{"doc":"def deps do [ {:jose_utils, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"JOSEUtils - Installation","type":"extras"},{"doc":"JWS @spec verify( jws :: serialized(), jwk_or_jwks :: JOSEUtils.JWK.t() | [JOSEUtils.JWK.t()], allowed_algs :: [JOSEUtils.JWA.sig_alg()] ) :: {:ok, {verified_content :: binary(), JOSEUtils.JWK.t()}} | :error JWE @spec decrypt( jwe :: serialized(), jwk_or_jwks :: JOSEUtils.JWK.t() | [JOSEUtils.JWK.t()], allowed_algs :: [JOSEUtils.JWA.enc_alg()], allowed_encs :: [JOSEUtils.JWA.enc_enc()] ) :: {:ok, {decrypted_message :: binary(), JOSEUtils.JWK.t()}} | :error JWK @spec sig_alg_digest(t()) :: atom() @spec verify(t()) :: result() JWKS @spec signature_keys( t(), alg_or_algs :: JOSEUtils.JWA.sig_alg() | [JOSEUtils.JWA.sig_alg()] | nil ) :: t() @spec verification_keys( t(), alg_or_algs :: JOSEUtils.JWA.sig_alg() | [JOSEUtils.JWA.sig_alg()] | nil ) :: t() @spec encryption_keys( t(), alg_or_algs :: JOSEUtils.JWA.enc_alg() | [JOSEUtils.JWA.enc_alg()] | nil, enc_or_encs :: JOSEUtils.JWA.enc_enc() | [JOSEUtils.JWA.enc_enc()] | nil ) :: t() @spec decryption_keys( t(), alg_or_algs :: JOSEUtils.JWA.enc_alg() | [JOSEUtils.JWA.enc_alg()] | nil, enc_or_encs :: JOSEUtils.JWA.enc_enc() | [JOSEUtils.JWA.enc_enc()] | nil ) :: t()","ref":"readme.html#functions","title":"JOSEUtils - Functions","type":"extras"}]